Redmine - Feature #1237

Add support for two-factor authentication

2008-05-14 20:28 - Sam McCoy

Status: Closed Start date: 2008-05-14
Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Accounts / authentication Estimated time: 0.00 hour
Target version: 4.2.0

Resolution: Fixed

Description

Please add support for a one time password service, such as Yubikey, and add the ability to authenticate against a two-factor

authentication system (as in RSA SecurlD).

Related issues:
Related to Redmine - Feature #699: OpenlID login

Related to Redmine - Defect #33925: ArgumentError in lib/redmine/twofa/base.r...
Related to Redmine - Patch #33929: Encrypt / decrypt TOTP secret keys with 'r...
Related to Redmine - Defect #33932: Can't view "My account" page when 2fa is ...

Related to Redmine - Defect #34233: otpauth uri should include a login id, no...

Related to Redmine - Defect #34234: Use Setting.host_name instead of Setting....

Related to Redmine - Feature #34241: Include twofa_scheme (two-factor scheme...

Related to Redmine - Feature #34495: Don't show "Two-factor authentication” o...

Related to Redmine - Defect #34618: Cannot sign in when both enabling two-fac...

Related to Redmine - Feature #34070: Allow setting a grace period when forcin...

Related to Redmine - Patch #35372: Better presentation for 2FA recovery codes

Related to Redmine - Feature #35001: Disable API authentication with username...

Related to Redmine - Feature #35086: Please consider changing the way how 2FA...

Related to Redmine - Feature #35439: Option to require 2FA only for users wit...

Related to Redmine - Defect #35417: User sessions not reset after 2FA activation

Related to Redmine - Feature #35934: Show 2FA status in users list from admin...

Blocks Redmine - Feature #31920: Require 2FA only for certain user groups
Closed
Closed
Closed
Closed
Closed
Closed
New

Closed
Closed
Closed
Closed
Closed
Closed

2008-02-20

Associated revisions

Revision 19988 - 2020-08-29 08:21 - Go MAEDA
Adds two factor authentication support (#1237).

Patch by Felix Schéfer.

Revision 19989 - 2020-08-29 08:37 - Go MAEDA

Adds a setting to disable/enable/require 2fa auth (#1237).
Patch by Felix Schéfer.

Revision 19990 - 2020-08-29 08:51 - Go MAEDA
Backup codes for 2fa auth (#1237).

Patch by Felix Schéfer.

Revision 19991 - 2020-08-29 09:07 - Go MAEDA
Integration test for 2fa auth (#1237).

Patch by Jens Kramer.

Revision 19992 - 2020-08-29 09:25 - Go MAEDA
RuboCop: Disable Rails/FilePath and Style/ClassVars in lib/redmine/twofa.rb (#1237).

Revision 19993 - 2020-08-29 09:30 - Go MAEDA
Update locales (#1237).

Revision 19995 - 2020-08-31 10:29 - Go MAEDA

Fix that Redmine::Twofa::Base raises ArgumentError in development mode (#1237, #33925).

Revision 19997 - 2020-08-31 23:45 - Go MAEDA

Fix an error "uninitialized constant Redmine::Twofa::Base" when accessing My account in production mode (#1237, #33932).

Revision 20005 - 2020-09-05 08:24 - Go MAEDA
Rake tasks db:encrypt and db:decrypt now supports TOTP secret keys (#1237, #33929).

Revision 20006 - 2020-09-05 10:34 - Go MAEDA

Remove mistakenly added database_cipher_key from config/configuration.yml.example (#1237, #33929).

Revision 20307 - 2020-11-09 03:41 - Go MAEDA
otpauth uri should include a login id, not an email address (#1237, #34233).

Revision 20308 - 2020-11-09 07:37 - Go MAEDA

Use Setting.host_name instead of Setting.app_title as TOTP issuer to avoid name collision with other instances or apps (#1237, #34234).

Revision 20691 - 2020-12-25 09:30 - Go MAEDA

Don't show "Two-factor authentication" on new user form (#1237, #34495).

Revision 20734 - 2021-02-02 08:15 - Go MAEDA

Fix redirect loop when both enabling two-factor authentication and changing password are required (#1237, #34618).

Patch by Go MAEDA.

History

#1 - 2008-05-15 10:50 - Thomas Lecavelier

Good idea. Since OpenlID (#699) should be implemented too, it could be an idea to build a plugin system for authentication, to help introduction of a
new authentification systems.

#2 - 2011-09-13 10:53 - Etienne Massip

- Category set to Accounts / authentication

#3 - 2014-10-10 22:20 - Nathanael Hansen

+1 for dual-factor authentication support

Thanks!

#4 - 2015-03-18 12:25 - Blagoy Chepelov

+1 for two factory auth, YubiKey for instance it is open source and well documented

#5 - 2015-08-27 14:43 - Ouss Orange

+1 for Two Factory Authentication support

#6 - 2016-01-12 12:48 - eric c

+1 for Two Factory Authentication, maybe using the one-time-password with the Google Authenticator App
#7 - 2016-04-29 21:53 - Stephen Yeargin
This page (http:/developers-club.com/posts/168063/) describes a potential method of using a low-level service to achieve this. It looks fairly

complicated to set up, but it may help somebody. Would love to hear if it works.

#8 - 2017-01-20 18:55 - Fabian Rodriguez
There is a plugin for 2FA including support for SMS, Telegram and authenticator apps:
http://www.redmine.org/plugins/redmine_2fa

#9 - 2018-01-02 18:42 - Felix Schéfer

- File 0001-2-factor-authentication-using-TOTP.patch added

- File 0002-2-factor-authentication-disabled-enabled-required.patch added
- File 0003-Backup-codes-for-2-factor-authentication.patch added

Please find attached a proposed 2-factor authentication implementation for Redmine. The core logic for the TOTP scheme is implemented using the
rotp gem.

The first of the 3 attached patches is an extendable implementation of 2-factor authentication including a default TOTP scheme. The second patch
adds an option to require, optionally enable or disable 2-factor authentication for all users. The third patch adds support for creating and using backup
codes.

The feature is implemented so that new 2-factor authentication schemes other than TOTP can easily be added, for example in a plugin. All
scheme-specific localisation strings have a __#{scheme}___identifier, generally this is easier to do with namespaces, i.e.
twofa.#{scheme}.some_string instead of twofa__#{scheme}__some_string, but the current Redmine tooling only supports top-level localisation keys.

Please furthermore note that the base 2-factor authentication is structured so that it can accommodate computed second factors (TOTP, HOTP,
Keyfobs, ...) or sent second factors (sending the code via SMS, telegram, ...). Those sent second factors can contain a link with the code as query
parameter so that the user can click on the link instead of copying the code into the text field in Redmine, which is why all actions that accept a
2-factor authentication code are also available via the GET verb.

We have rolled out this feature to Planio a few weeks ago, the customers that use this feature have been happy with it so far.

Last but not least, we have created a plugin implementing a 2-factor email scheme to demonstrate how additional schemes can be implemented, and
how a scheme sending the one-time-password instead of using a generated one can work with the patches proposed above. Please note that this
plugin is only for demonstration purposes and should probably not be used in production, refer to the "Security considerations" section of the
README for more details.

#10 - 2018-01-02 18:45 - Jan from Planio www.plan.io

- Target version set to Candidate for next major release

#11 - 2018-01-02 18:46 - Jan from Planio www.plan.io
- Tracker changed from Feature to Patch

- Status changed from New to Needs feedback

#12 - 2018-01-04 07:45 - Go MAEDA

- File 2fa-setting@2x.png added

- File 2fa-my-account@2x.png added

- File 2fa-enabling@2x.png added

- File 2fa-enter-auth-code@2x.png added

Thank Felix and Planio for sharing the patch. | think this is an outstanding enhancement because 2FA is helpful to keep accounts secure and it is a
must-have feature for modern cloud-based applications. Many users should welcome this feature.

| tried out the patch. It works very fine.

2FA is optional by default. Users can choose whether to use 2FA or not:
Settings

General || Display || Authentication || API | Projects || Issue tracking || Time tracking | Files || Email notification 4 »

Authentication required
Autologin  disabled
Self-registration manual account activation
Show custom fields on registration
Allow users to delete their own account
Minimum password length g
Require password change after disabled

Allow password reset via email

Two-factor authentication optional
Setting disabled will deactivate and unpair two-factor authentication devices for
all users.
Setting required will require all users to set up two-factor authentication at their
next login.

Maximum number of additional email 5
addresses

Allow OpenlD login and registration [

Users can enable 2FA on "My account" page:

My account [ Emails I Change password

Information Email notifications

First name * Redmine
For any event on all my projects

Last name * aAdmin -
[ I don't want to be notified of changes that I make

Email * admin@somenet.foo myself

Language | (auto) <

Preferences
Two-factor Enable authenticator app . .
authentication Hide my email address

Phone number Time zone

Money Display comments |n chronological order

Warn me when leaving a
Save page with unsaved text

Font used for text areas Default font

Enabling 2FA:
Enable two-factor authentication

Scan this QR code or enter the plain text key into a TOTP
app (e.g. Google Authenticator, Authy, Duo Mobile) and
enter the code in the field below to activate two-factor
authentication.

Plain text key pvub uo2c 2fz5 auré

Code|

Activate

One time password is required as well as login id and password when you sign in:

Sign in Register

Redmine

Two-factor authentication

Please enter your two-factor authentication
code.

Code

21419

Login

#13 - 2018-01-07 01:33 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Setting target version to 4.1.0.

#14 - 2018-01-22 07:36 - Mayank Ahuja

What is the release date of 4.1.0. any tentative dates ?

#15 - 2018-01-28 14:25 - Go MAEDA
- File ja-translation-2fa.diff added

| have translated messages on this patch.

#16 - 2018-01-29 05:19 - Go MAEDA
- File ja-translation-2fa.diff added

This is an updated Japanese translation. There were 2 untranslated strings in the previous patch.
#17 - 2018-01-29 05:20 - Go MAEDA
- File deleted (ja-translation-2fa.diff)

#18 - 2018-03-03 10:33 - Go MAEDA

Felix, could you add tests for this feature?

#19 - 2018-04-10 05:43 - Enziin System
Thanks Felix!

When applying for the admin account, everything is OK.

But if | applying for normal account user, its error.

Started POST "/my/twofa/totp/activate/init" for 127.0.0.1 at 2018-04-10 06:15:23 +0000
Processing by TwofaController#activate_init as HTML

Parameters:
{"authenticity_token"=>"Yf7MaaWDeovRvA9loRYE7hyAZs6aWjgvKB1ELuytNPfzuhNOlhwclzZWQ+df6llld8ksBuclPKCVepCwo0OsAhA==",
"scheme"=>"totp"}

Current user: kevin-nguyen (id=6)

Redirected to https://www.enziin.com/my/twofa/totp/activate/confirm

Completed 302 Found in 73ms (ActiveRecord: 12.5ms)

Started GET "/my/twofa/totp/activate/confirm" for 127.0.0.1 at 2018-04-10 06:15:23 +0000
Processing by TwofaController#activate_confirm as HTML

Parameters: {"scheme"=>"totp"}

Current user: kevin-nguyen (id=6)

Rendered twofa/totp/_new.html.erb (422.5ms)

Rendered my/_sidebar.html.erb (14.1ms)

Rendered twofa/activate_confirm.html.erb within layouts/base (459.4ms)

Completed 500 Internal Server Error in 478ms (ActiveRecord: 10.3ms)

ActionView::Template::Error (No route matches {:action=>"destroy", :controller=>"twofa", :scheme=>"totp"}):
4: <%-=I(:field_created_on)%>: <%= format_time(@user.created_on) ></p>

5:
6: < if @user.own_account_deletable? >

7: <p><= link_to(I(:button_delete_my_account), {:action => 'destroy'}, :class => ‘icon icon-del') ></p>

8:<end >

9:

10: <h4><= I(:label_feeds_access_key) %></h4>

app/views/my/_sidebar.html.erb:7:in *_app_views_my__sidebar_html_erb__ 731617039739943373_70003011594380'
app/views/twofa/activate_confirm.html.erb:22:in “block in app_views_twofa_activate _confirm_html_erb_76021097380460310_46976643820260'
app/views/twofa/activate_confirm.html.erb:21:in *_app_views_twofa_activate_confirm_html_erb_ 76021097380460310_46976643820260"'
lib/redmine/sudo_mode.rb:63:in “sudo_mode'

| fixed it:
In the "my/_sidebar.html.erb" by adding :controller=>"my"
<% if @user.own_account_deletable? >

<p><= link_to(I(:button_delete_my_account), {:action => 'destroy’, :controller=>"my"}, :class => 'icon icon-del') ></p>
<end %>

#20 - 2019-05-28 00:29 - Go MAEDA

- Target version changed from 4.1.0 to 4.2.0

#21 - 2019-08-14 13:05 - Felix Schafer
- File 0001-2-factor-authentication-using-TOTP.patch added

The rotp gem has changed its API, the attached 0001 patch replaces the original patch and fixes the API changes with rotp.

#22 - 2019-08-14 13:13 - Felix Schéfer

Enziin System wrote:

But if | applying for normal account user, its error.

| can see what causes the error. The method to create the link the user can use to delete the user's own account expects the my/_sidebar.html.erb
partial to be used only on /my/account or /my/password pages.
| think this should be made more explicit/fixed in Redmine core so that other plugins that may use my/_sidebar.html.erb do not break either.
Maeda-san, do you agree? If yes | can open an issue and propose a patch for my/_sidebar.html.erb.

#23 - 2019-08-17 15:47 - Jens Kramer

- File 0001-adds-two-factor-authentication-support.patch added

- File 0002-adds-a-setting-to-disable-enable-require-2fa-auth.patch added
- File 0003-backup-codes-for-2fa-auth.patch added

- File 0004-adds-integration-test-for-totp-two-factor-auth.patch added

| rebased the patch series on top of current master and added an integration test covering the basic activation / totp and backup code functionality. |
also fixed the above problem by making the account deletion link more explicit.

#24 - 2019-08-17 16:01 - Marius BALTEANU

Jens Kramer wrote:

| rebased the patch series on top of current master and added an integration test covering the basic activation / totp and backup code
functionality. | also fixed the above problem by making the account deletion link more explicit.

Jens, | think something went wrong because your patches are empty.

#25 - 2019-08-17 16:05 - Jens Kramer

- File 0001-adds-two-factor-authentication-support.patch added

- File 0002-adds-a-setting-to-disable-enable-require-2fa-auth.patch added
- File 0003-backup-codes-for-2fa-auth.patch added

- File 0004-adds-integration-test-for-totp-two-factor-auth.patch added

| apologize, uploading files on an ipad is still a problem unfortunately :)

#26 - 2019-08-17 16:08 - Jens Kramer

the fifth patch of the series actually adds a new feature on top of this so | created a separate issue for it: #31920

#27 - 2019-08-18 14:35 - Go MAEDA
- Blocks Feature #31920: Require 2FA only for certain user groups added

#28 - 2019-08-20 08:46 - Jens Kramer
- File 0001-adds-two-factor-authentication-support.patch added

Updated first patch that adds a require statement necessary for the patch to work in production.

#29 - 2019-09-28 08:46 - Go MAEDA
- File 0001-adds-two-factor-authentication-support-r18547.patch added
- File 0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18547.patch added

I have slightly fixed two of the four patches to apply to the latest trunk, r18547. You can add two-factor authentication by applying the following
patches.

e attachment:0001-adds-two-factor-authentication-support-r18547.patch (updated)

e attachment:0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18547.patch (updated)
L]

L]

0003-backup-codes-for-2fa-auth.patch
0004-adds-integration-test-for-totp-two-factor-auth.patch

#30 - 2019-09-28 10:33 - Go MAEDA

- Status changed from Needs feedback to New
- Assignee set to Jean-Philippe Lang

- Target version changed from 4.2.0 to 4.1.0

Two-factor authentication is becoming a must-have feature nowadays. Thanks to Planio, now there is a complete and ready-to-commit patch with test
code.
I think it is the time to commit the patch. Setting the target version to 4.1.0.
#31 - 2019-09-28 12:19 - Marius BALTEANU
Go MAEDA wrote:

Two-factor authentication is becoming a must-have feature nowadays. Thanks to Planio, now there is a complete and ready-to-commit patch
with test code.

| thik it is the time to commit the patch. Setting the target version to 4.1.0.

Totally agree with you regarding the need for this feature.

Regarding the patches, I've just tested the entire work and it looks very good to me. All the tests pass on MySQL 5.7 and Postgres 10.9 (
https:/gitlab.com/redmine-org/redmine/pipelines/85148957).

I've found only some minor things:

Code related:
1. The db migration version should be 5.2 in the migration files. Also, the filenames should be updated to the current date before committing.

Mariuss—-MacBook-Pro:redmine mariusbalteanu$ git diff
diff --git a/db/migrate/20170711134351_add_twofa_scheme_to_user.rb b/db/migrate/20170711134351_add_twofa_schem
e_to_user.rb
index ac3f49717..ealb48fc8 100644
-—— a/db/migrate/20170711134351_add_twofa_scheme_to_user.rb
+++ b/db/migrate/20170711134351_add_twofa_scheme_to_user.rb
@@ -1,4 +1,4 qe
-class AddIwofaSchemeToUser < ActiveRecord::Migration[4.2]
+class AddIwofaSchemeToUser < ActiveRecord::Migration[5.2]
def change
add_column :users, :twofa_scheme, :string
end
diff --git a/db/migrate/20170711134352_add_totp_to_user.rb b/db/migrate/20170711134352_add_totp_to_user.rb
index d24bdba86..6842878e3 100644
——— a/db/migrate/20170711134352_add_totp_to_user.rb
+++ b/db/migrate/20170711134352_add_totp_to_user.rb
@@ -1,4 +1,4 @@
—class AddTotpToUser < ActiveRecord::Migration[4.2]
+class AddTotpToUser < ActiveRecord::Migration[5.2]
def change
add_column :users, :twofa_totp_key, :string
add_column :users, :twofa_totp_last_used_at, :integer

2. The following new Rubocop warnings are introduced:

Offenses:

app/controllers/account_controller.rb:255:5: C: Rails/Blank: Use if Quser.blank? instead of unless Quser.prese
e o

unless @user.present?
app/controllers/twofa_backup_codes_controller.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comme
nt # frozen_string literal: true.
class TwofaBackupCodesController < ApplicationController
app/controllers/twofa_controller.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comment # frozen_s
tring_literal: true.
class TwofaController < ApplicationController
app/controllers/twofa_controller.rb:78:5: C: Rails/Blank: Use if twofa_scheme.blank? instead of unless twofa_s
cheme.present?.

unless twofa_scheme.present?
app/helpers/twofa_helper.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comment # frozen_string_li
teral: true.
module TwofaHelper
lib/redmine/twofa.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comment # frozen_string_literal:
true.
module Redmine

~
lib/redmine/twofa.rb:25:5: W: Lint/UselessAccessModifier: Useless private access modifier.
private

AAAAAAA

lib/redmine/twofa/base.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comment # frozen_string_lite
ral: true.
module Redmine

~

lib/redmine/twofa/base.rb:97:29: C: Style/ParenthesesAroundCondition: Don't use parentheses around the conditi
on of an unless.
return false unless (Quser.present? && @user == user_from_code)

AAAANAAAAAAANAAAAAAAANAAAAAAANAAAAAANAAAAAAANAAAANAAN

lib/redmine/twofa/totp.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comment # frozen_string_lite
ral: true.
module Redmine

~

test/integration/twofa_test.rb:1:1: C: Style/FrozenStringLiteralComment: Missing magic comment # frozen_string
_literal: true.
require File.expand_path('../../test_helper', _ FILE_ )

~

test/integration/twofa_test.rb:124:1: C: Layout/EmptyLinesAroundBlockBody: Extra empty line detected at block
body end.

3. Redmine copywriting "# Redmine - project management software etc" is missing from the files added by these patches.
Functional:
4. Users should not be allowed to disable 2FA authentication when the "Two-factor authentication" is set to "required" in administration. Currently, the

user can disable it, but at the next login, he is be prompted again to configure 2FA. | propose to not allow users to disable 2FA authentication from the
beginning.

#32 - 2019-10-04 13:00 - Marius BALTEANU
- Assignee changed from Jean-Philippe Lang to Go MAEDA

- Target version changed from 4.1.0 to 4.2.0

Please reassign this to 4.1.0 after the above issues are fixed.

#33 - 2019-10-05 11:08 - Go MAEDA
- File 0001-adds-two-factor-authentication-support-r18593.patch added
- File 0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18593.patch added
- File 0003-backup-codes-for-2fa-auth-r18593.patch added
- File 0004-adds-integration-test-for-totp-two-factor-auth-r18593.patch added
- Subject changed from Add support for one time passwords or two-factor authentication to Add support for two-factor authentication
- Target version changed from 4.2.0 to 4.1.0
Marius, thank you for reviewing the patch series. Here are patches to commit:
e attachment:0001-adds-two-factor-authentication-support-r18593.patch
e attachment:0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18593.patch
¢ attachment:0003-backup-codes-for-2fa-auth-r18593.patch
e attachment:0004-adds-integration-test-for-totp-two-factor-auth-r18593.patch
Marius BALTEANU wrote:

1. The db migration version should be 5.2 in the migration files. Also, the filenames should be updated to the current date before committing.

Applied the patch you posted in #1237#note-31. But the filenames are not changed yet.

2. The following new Rubocop warnings are introduced:

All RuboCop warnings are fixed.

3. Redmine copywriting "# Redmine - project management software etc" is missing from the files added by these patches.

Done.

4. Users should not be allowed to disable 2FA authentication when the "Two-factor authentication" is set to "required" in administration.
Currently, the user can disable it, but at the next login, he is be prompted again to configure 2FA. | propose to not allow users to disable 2FA
authentication from the beginning.

| think the behavior should be kept. It is necessary to allow users to discard the current 2FA config and set up a new config by themself.

Assume that a user lost their authentication device but they have backup codes, and they want to set up a new authentication device. They can
discard the 2FA config for the lost device and configure 2FA for the new device without the help of admins by the following steps:

1. Login with id, password, and a backup code

2. Go to "My account" and Disable 2FA (another backup code is required)
3. Logout

4. Login with id and password. Redmine requires the user to configure 2FA
5. Configure 2FA for the new device

#34 - 2019-10-09 08:09 - Marius BALTEANU
Thanks for updating the patches, | can confirm that all code related issues have been fixed.

One more thing, it seems (at least on my environment) that the patches doesn't apply cleanly anymore:

o

mariusbalteanu@Mariuss-MacBook-Pro redmine % curl http://www.redmine.org/attachments/download/24068/0001-adds—
two-factor—authentication-support-rl18593.patch | patch -pl

% Total % Received % Xferd Average Speed Time Time Time Current
Dload Upload Total Spent Left Speed
100 32734 0 32734 0 0 138k @ ==8g=—8== ==g=—8=— =—g=—g=— I3@K

patching file Gemfile

Hunk #1 succeeded at 21 (offset 3 lines).

patching file app/controllers/account_controller.rb
patching file app/controllers/twofa_controller.rb

patching file app/models/user.rb

patching file app/views/account/twofa_confirm.html.erb
patching file app/views/my/_sidebar.html.erb

patching file app/views/my/account.html.erb

patching file app/views/twofa/activate_confirm.html.erb
patching file app/views/twofa/deactivate_confirm.html.erb
patching file app/views/twofa/totp/_new.html.erb

patching file app/views/users/_form.html.erb

patching file config/locales/de.yml

Hunk #2 FAILED at 1299.

1 out of 2 hunks FAILED -- saving rejects to file config/locales/de.yml.rej
patching file config/locales/en.yml

Hunk #1 succeeded at 1101 (offset 1 line).

Hunk #2 succeeded at 1281 (offset 1 line).

patching file config/routes.rb

patching file db/migrate/20170711134351_add_twofa_scheme_to_user.rb
patching file db/migrate/20170711134352_add_totp_to_user.rb
patching file lib/redmine.rb

patching file lib/redmine/twofa.rb

patching file lib/redmine/twofa/base.rb

patching file lib/redmine/twofa/totp.rb

patching file public/stylesheets/application.css

patching file public/stylesheets/responsive.css

Can you check, please? | think it is because of r18596.

#35 - 2019-10-09 16:55 - Go MAEDA
- File 0001-adds-two-factor-authentication-support-r18640.patch added
- Assignee changed from Go MAEDA to Jean-Philippe Lang

Marius, thank you for reviewing the patch series. | have updated one of the four patches.
Patches to commit:
attachment:0001-adds-two-factor-authentication-support-r18640.patch (updated)
attachment:0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18593.patch

attachment:0003-backup-codes-for-2fa-auth-r18593.patch
attachment:0004-adds-integration-test-for-totp-two-factor-auth-r18593.patch

#36 - 2019-10-24 10:32 - Go MAEDA
- File deleted (0001-adds-two-factor-authentication-support-r18640.patch)
#37 - 2019-10-24 10:32 - Go MAEDA
- File deleted (0001-adds-two-factor-authentication-support-r18593.patch)

#38 - 2019-10-24 10:32 - Go MAEDA
- File deleted (0001-adds-two-factor-authentication-support-r18547.patch)

#39 - 2019-10-24 10:33 - Go MAEDA
- File deleted (0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18547.patch)

#40 - 2019-10-24 10:36 - Go MAEDA
- File 0001-adds-two-factor-authentication-support-r18859.patch added

Updated the patch for the current trunk r18859.
Patches to commit:

e attachment:0001-adds-two-factor-authentication-support-r18859.patch (updated)
¢ attachment:0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18593.patch
.

attachment:0003-backup-codes-for-2fa-auth-r18593.patch
attachment:0004-adds-integration-test-for-totp-two-factor-auth-r18593.patch

#41 - 2019-11-02 08:36 - Jean-Philippe Lang
- Target version changed from 4.1.0 to 5.0.0

Reassigning this huge change to the next major.

#42 - 2019-11-02 09:11 - Go MAEDA
- Target version changed from 5.0.0 to 4.2.0

Jean-Philippe Lang wrote:

Reassigning this huge change to the next major.

| think the next major release is 4.2.0.

#43 - 2020-08-26 18:30 - Go MAEDA

- File 0001-Adds-two-factor-authentication-support-1237.patch added

- File 0002-Adds-a-setting-to-disable-enable-require-2fa-auth-12.patch added
- File 0003-Backup-codes-for-2fa-auth-1237.patch added

- File 0004-Integration-test-for-2fa-auth-1237.patch added

- Assignee changed from Jean-Philippe Lang to Go MAEDA

| have emailed Jean-Philippe Lang and got his approval to commit this patch for Redmine 4.2.0.

Here are the final patches to be committed. | will commit the patches in a few days to a week.

e 0001-Adds-two-factor-authentication-support-1237.patch

¢ 0002-Adds-a-setting-to-disable-enable-require-2fa-auth-12.patch
e 0003-Backup-codes-for-2fa-auth-1237.patch

e 0004-Integration-test-for-2fa-auth-1237.patch

#44 - 2020-08-26 18:31 - Go MAEDA
- File deleted (0001-adds-two-factor-authentication-support-r18859.patch)

#45 - 2020-08-26 18:31 - Go MAEDA
- File deleted (0004-adds-integration-test-for-totp-two-factor-auth-r18593.patch)

#46 - 2020-08-26 18:31 - Go MAEDA
- File deleted (0003-backup-codes-for-2fa-auth-r18593.patch)
#47 - 2020-08-26 18:31 - Go MAEDA
- File deleted (0002-adds-a-setting-to-disable-enable-require-2fa-auth-r18593.patch)

#48 - 2020-08-26 18:44 - Marius BALTEANU
Go MAEDA wrote:

| have emailed Jean-Philippe Lang and got his approval to commit this patch for Redmine 4.2.0.

Great news!

#49 - 2020-08-27 08:35 - Bernhard Rohloff
Go MAEDA wrote:

| have emailed Jean-Philippe Lang and got his approval to commit this patch for Redmine 4.2.0.

That's so cool! Thank you for your efforts.

#50 - 2020-08-29 09:31 - Go MAEDA
- Tracker changed from Patch to Feature
- Status changed from New to Closed

- Resolution set to Fixed

Committed the patches from Planio. Thank you for your great contribution.

#51 - 2020-08-30 09:24 - Go MAEDA

- Related to Defect #33925: ArgumentError in lib/redmine/twofa/base.rb after updating a source file in development mode added

#52 - 2020-08-30 16:00 - Go MAEDA
- Related to Patch #33929: Encrypt / decrypt TOTP secret keys with ‘rake db:encrypt’ / “rake db:decrypt” added

#53 - 2020-08-31 06:31 - Go MAEDA
- Related to Defect #33932: Can't view "My account" page when 2fa is setting to optional added

#54 - 2020-11-08 08:55 - Go MAEDA
- Related to Defect #34233: otpauth uri should include a login id, not an email address added

#55 - 2020-11-08 14:14 - Go MAEDA

- Related to Defect #34234: Use Setting.host_name instead of Setting.app _title as TOTP issuer to avoid name collision with other instances or apps
added

#56 - 2020-11-10 03:43 - Go MAEDA

- Related to Feature #34241: Include twofa_scheme (two-factor scheme) column when exporting users to CSV added

#57 - 2020-12-23 09:57 - Go MAEDA

- Related to Feature #34495: Don't show "Two-factor authentication” on new user form added

#58 - 2021-01-23 08:13 - Go MAEDA

- Related to Defect #34618: Cannot sign in when both enabling two-factor authentication and changing password are required added

#59 - 2021-04-19 09:13 - Marius BALTEANU
- Related to Feature #34070: Allow setting a grace period when forcing 2FA added

#60 - 2021-06-09 11:10 - Marius BALTEANU
- Related to Patch #35372: Better presentation for 2FA recovery codes added

#61 - 2021-06-22 20:07 - Marius BALTEANU

- Related to Feature #35001: Disable API authentication with username and password when two-factor authentication is enabled for the user added
#62 - 2021-06-22 23:05 - Marius BALTEANU
- Related to Feature #35086: Please consider changing the way how 2FA is set up added

#63 - 2021-06-22 23:24 - Marius BALTEANU
- Related to Feature #35439: Option to require 2FA only for users with administration rights added

#64 - 2021-07-27 23:00 - Marius BALTEANU

- Related to Defect #35417: User sessions not reset after 2FA activation added

#65 - 2021-11-06 21:30 - Marius BALTEANU

- Related to Feature #35934: Show 2FA status in users list from administration with option to filter added

Files

0002-2-factor-authentication-disabled-enabled-required.patch 13.8 KB 2018-01-02 Felix Schafer
0001-2-factor-authentication-using-TOTP.patch 30 KB 2018-01-02 Felix Schafer
ja-translation-2fa.diff 4.21 KB 2018-01-29 Go MAEDA
0001-2-factor-authentication-using-TOTP.patch 27.6 KB 2019-08-14 Felix Schéafer
0001-adds-two-factor-authentication-support.patch 3.14 KB 2019-08-17 Jens Kramer
0002-adds-a-setting-to-disable-enable-require-2fa-auth.patch 3.15 KB 2019-08-17 Jens Kramer
0003-backup-codes-for-2fa-auth.patch 3.13 KB 2019-08-17 Jens Kramer
0004-adds-integration-test-for-totp-two-factor-auth.patch 3.15 KB 2019-08-17 Jens Kramer
0002-adds-a-setting-to-disable-enable-require-2fa-auth.patch 13.8 KB 2019-08-17 Jens Kramer
0001-adds-two-factor-authentication-support.patch 30.4 KB 2019-08-17 Jens Kramer
0004-adds-integration-test-for-totp-two-factor-auth.patch 4.83 KB 2019-08-17 Jens Kramer
0003-backup-codes-for-2fa-auth.patch 18.9 KB 2019-08-17 Jens Kramer
0001-adds-two-factor-authentication-support.patch 30.8 KB 2019-08-20 Jens Kramer
0001-Adds-two-factor-authentication-support-1237.patch 34.5 KB 2020-08-26 Go MAEDA
0002-Adds-a-setting-to-disable-enable-require-2fa-auth-12.patch 13.9 KB 2020-08-26 Go MAEDA
0003-Backup-codes-for-2fa-auth-1237.patch 20.6 KB 2020-08-26 Go MAEDA
0004-Integration-test-for-2fa-auth-1237.patch 5.74 KB 2020-08-26 Go MAEDA
